import os
from cryptography.hazmat.primitives.ciphers import Cipher, algorithms, modes
from cryptography.hazmat.backends import default_backend

backend = default_backend()

output_file = 'encrypted.txt'

# generate random padding and IV
padding = os.urandom(1)
iv = os.urandom(16)

passphrase = ''
while True:
    passphrase = raw_input('Enter a passphrase for encryption: ')
    if len(passphrase) < 32:
        print("Passphrase must be at least 32 characters long")
    else:
        break
key = passphrase[:32]

# a secret message to be encrypted
message = raw_input('Enter a message to encrypt: ')
while len(message) % 16 != 0:   # ensure multiple of 16
    message = padding + message
    
    
cipher = Cipher(algorithms.AES(key), modes.CBC(iv), backend=backend)
encryptor = cipher.encryptor()

# encrypt the message
ct = encryptor.update(message) + encryptor.finalize()

# write output
with open(output_file, 'w') as fp:
    fp.write(iv)
    fp.write(padding)
    fp.write(ct)
    
print("The encrypted message is written to " + output_file)
