import os
from cryptography.hazmat.primitives.ciphers import Cipher, algorithms, modes
from cryptography.hazmat.backends import default_backend

backend = default_backend()

while True:
    file_name = raw_input('Enter a name of the file to decrypt: ')  
    if os.path.exists(file_name):
        break
    else:
        print('File does not exist')
    

passphrase = ''
while True:
    passphrase = raw_input('Enter a passphrase for encryption: ')
    if len(passphrase) < 32:
        print("Passphrase must be at least 32 characters long")
    else:
        break
key = passphrase[:32]

with open(file_name, 'r') as fp:
    # extract iv and pad character first
    iv = fp.read(16)
    padding = fp.read(1)
    ct = fp.read()
    
cipher = Cipher(algorithms.AES(key), modes.CBC(iv), backend=backend)

# decrypt the message
decryptor = cipher.decryptor()
message = decryptor.update(ct) + decryptor.finalize()

# remove padding
message = message.lstrip(padding)

print("The secret message: " + message)
